diff --git a/lib/hive/commands/uninstall.rb b/lib/hive/commands/uninstall.rb
new file mode 100644
index 000000000..f39244827
--- /dev/null
+++ b/lib/hive/commands/uninstall.rb
@@ -0,0 +1,231 @@
+require "open3"
+
+module Hive
+  module Commands
+    # `hive uninstall` (packaging plan U8): clean removal that can never
+    # destroy user work.
+    #
+    # Layered behaviour:
+    #   1. Daemon service registration — unloaded/disabled and the unit
+    #      file removed via Hive::Service.remove! (always, best-effort).
+    #   2. Channel-managed bits — brew / pacman manage their own binaries,
+    #      so the command prints the EXACT native removal line for the
+    #      operator to run. The install.sh script channel removes its own
+    #      bundle + symlinks directly (it owns those files).
+    #   3. Project cleanup — strictly opt-in per registered project,
+    #      interactive prompts only. Removes exactly: the .hive-state
+    #      worktree, the hive/state branch, and the global-registry entry.
+    #      Accumulated outputs under .hive-state are PRESERVED BY DEFAULT —
+    #      even --purge never deletes them (--purge only makes layers 1–2
+    #      non-interactive). Non-TTY runs never delete project state.
+    #
+    # Skills installed into agent CLIs are never touched here; they are
+    # removed through each agent's own mechanism.
+    class Uninstall
+      EXIT_OK = 0
+
+      attr_reader :channel
+
+      def initialize(bin_path: File.expand_path($PROGRAM_NAME), runner: nil,
+                     output: $stdout, input: $stdin, purge: false,
+                     cleanup_projects: nil, repo: nil, service: nil)
+        @bin_path = bin_path
+        @runner = runner || Hive::Channel.default_runner
+        @output = output
+        @input = input
+        @purge = purge
+        # Test/automation hook: explicit per-project opt-in list of project
+        # names to clean. nil = interactive prompts (TTY) or skip (non-TTY).
+        @cleanup_projects = cleanup_projects
+        @repo = repo
+        # Injectable service backend (U6/U8); production resolves
+        # Hive::Service lazily.
+        @service = service
+      end
+
+      def call
+        @channel = begin
+          Hive::Channel.detect(bin_path: @bin_path, runner: @runner)
+        rescue Hive::Channel::AmbiguousChannel => e
+          warn "hive: #{e.message}"
+          warn "hive: proceeding with registration + project cleanup only"
+          :unknown
+        end
+
+        remove_service_registration
+        handle_channel_bits
+        cleanup_projects_interactive
+        say ""
+        say "hive: uninstall complete"
+        EXIT_OK
+      end
+
+      private
+
+      def remove_service_registration
+        svc = @service
+        if svc.nil?
+          require "hive/service"
+          svc = Hive::Service
+        end
+        return if svc.skipped?
+
+        say "hive: removing daemon service registration..."
+        svc.remove!(output: method(:say))
+      rescue StandardError => e
+        say "hive: warning — could not remove daemon service: #{e.class}: #{e.message}"
+      end
+
+      def handle_channel_bits
+        case @channel
+        when :brew
+          say ""
+          say "  Homebrew manages the hive binary. Finish uninstall with:"
+          say "    brew uninstall hive"
+          say "    brew untap <org>/hive   # if you no longer want the tap"
+        when :pacman
+          say ""
+          say "  pacman/AUR manages the hive binary. Finish uninstall with:"
+          say "    sudo pacman -Rns hive-bin"
+        when :script
+          remove_script_bundle!
+        else
+          say "hive: unknown install channel (#@bin_path); no package-manager step to run"
+        end
+      end
+
+      # Script-channel installs are fully owned by install.sh: remove the
+      # version bundle(s), the `current` symlink, and the ~/.local/bin/hive
+      # (+ hv fallback) symlink.
+      def remove_script_bundle!
+        root = Hive::Channel.script_bundle_root(@bin_path)
+        if root.nil?
+          say "hive: no install.sh bundle found for #@bin_path"
+          return
+        end
+
+        base = File.dirname(root)     # ~/.local/opt/hive/<version> → ~/.local/opt/hive
+        bin_dir = File.join(File.expand_path("~"), ".local", "bin")
+
+        say "hive: removing bundle #{root}"
+        FileUtils.rm_rf(root)
+
+        # Drop the `current` symlink when it now dangles.
+        current = File.join(base, "current")
+        if File.symlink?(current)
+          target = begin
+            File.readlink(current)
+          rescue StandardError
+            nil
+          end
+          FileUtils.rm_f(current) unless target && File.exist?(target)
+        end
+
+        %w[hive hv].each do |name|
+          link = File.join(bin_dir, name)
+          next unless File.symlink?(link)
+
+          target = begin
+            File.readlink(link)
+          rescue StandardError
+            nil
+          end
+          # Only remove symlinks that pointed INTO the removed bundle tree.
+          if target.to_s.start_with?(base)
+            FileUtils.rm_f(link)
+            say "hive: removed symlink #{link}"
+          end
+        end
+
+        # Remove the now-empty ~/.local/opt/hive directory.
+        begin
+          Dir.rmdir(base) if File.directory?(base) && Dir.empty?(base)
+        rescue StandardError
+          nil
+        end
+      end
+
+      def cleanup_projects_interactive
+        projects = begin
+          Hive::Config.registered_projects
+        rescue StandardError
+          []
+        end
+        return if projects.empty?
+
+        say ""
+        say "Registered projects:"
+        projects.each { |p| say "  - #{p['name']} (#{p['path']})" }
+        say ""
+
+        targets = select_cleanup_targets(projects)
+        targets.each { |name| remove_project_hive!(projects.find { |p| p["name"] == name }) }
+      end
+
+      # Per-project OPT-IN only. Non-TTY never deletes project state —
+      # even under --purge (purge is non-interactivity for the binary /
+      # registration layer, not a licence to delete work).
+      def select_cleanup_targets(projects)
+        # Explicit opt-in list (automation / --cleanup-projects flag) works
+        # regardless of TTY — it IS the explicit consent.
+        if @cleanup_projects.is_a?(Array)
+          return @cleanup_projects & projects.map { |p| p["name"] }
+        end
+
+        # Otherwise interactive prompts only; non-TTY never deletes state.
+        return [] unless @input.respond_to?(:tty?) && @input.tty?
+        return [] unless interactive_cleanup_allowed?
+
+        targets = []
+        projects.each do |p|
+          say "Remove hive state for #{p['name']} (worktree + hive/state branch)? [y/N]"
+          answer = @input.gets&.strip.to_s.downcase
+          targets << p["name"] if answer == "y" || answer == "yes"
+        end
+        targets
+      end
+
+      def interactive_cleanup_allowed?
+        # Hook for future policy gates; today every path that reaches here
+        # has already passed the TTY / explicit-list checks in
+        # select_cleanup_targets.
+        true
+      end
+
+      # Remove exactly one registered project's hive content:
+      #   * detach + delete the .hive-state worktree
+      #   * delete the orphan hive/state branch
+      #   * drop the global registry entry
+      # Task outputs live INSIDE .hive-state, so they go only when the
+      # operator explicitly opted in above.
+      def remove_project_hive!(project)
+        return unless project
+
+        path = project["path"]
+        state = File.join(path, ".hive-state")
+        say "hive: cleaning project #{project['name']}"
+
+        if File.exist?(state)
+          out, err, status = @runner.call(["git", "-C", path, "worktree", "remove", "--force", ".hive-state"])
+          unless status.success?
+            warn "hive: git worktree remove failed for #{project['name']}: #{err.strip}; forcing prune"
+            @runner.call(["git", "-C", path, "worktree", "prune"])
+            FileUtils.rm_rf(state)
+          end
+        end
+
+        _out, _err, branch_status = @runner.call(["git", "-C", path, "branch", "-D", "hive/state"])
+        warn "hive: no hive/state branch in #{path} (already clean)" unless branch_status.success?
+
+        Hive::Config.unregister_project(name: project["name"])
+        say "hive: removed hive content for #{project['name']}"
+      end
+
+      def say(message)
+        @output.puts message
+      rescue Errno::EPIPE
+        nil
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/update.rb b/lib/hive/commands/update.rb
new file mode 100644
index 000000000..000d518a8
--- /dev/null
+++ b/lib/hive/commands/update.rb
@@ -0,0 +1,97 @@
+require "open3"
+
+module Hive
+  module Commands
+    # `hive update` (packaging plan U7): upgrade hive through the channel
+    # that installed it. Hive NEVER copies or swaps its own binary — it
+    # detects the channel (Homebrew / pacman / install.sh bundle) and
+    # shells out to that channel's native updater, printing the exact
+    # command before running it.
+    #
+    #   :brew    → brew upgrade hive
+    #   :pacman  → yay -Syu hive-bin (or a printed `sudo pacman -Syu` hint;
+    #              sudo is never run from inside hive)
+    #   :script  → re-run the pinned install.sh one-liner (latest release)
+    #   :unknown → manual instructions; exit 1
+    #
+    # --dry-run prints what would run without executing it.
+    class Update
+      EXIT_OK = 0
+      EXIT_MANUAL = 1
+
+      CHANNEL_LABELS = {
+        brew: "Homebrew",
+        pacman: "pacman",
+        script: "install.sh bundle",
+        unknown: "unknown"
+      }.freeze
+
+      attr_reader :channel
+
+      def initialize(bin_path: File.expand_path($PROGRAM_NAME), runner: nil,
+                     output: $stdout, dry_run: false, repo: nil)
+        @bin_path = bin_path
+        @runner = runner || Hive::Channel.default_runner
+        @output = output
+        @dry_run = dry_run
+        @repo = repo
+      end
+
+      def call
+        @channel = Hive::Channel.detect(bin_path: @bin_path, runner: @runner)
+
+        if @channel == :unknown
+          print_unknown_channel_help
+          return EXIT_MANUAL
+        end
+
+        command = Hive::Channel.upgrade_command(@channel, runner: @runner, repo: @repo)
+        if command.nil?
+          print_pacman_hint
+          return EXIT_MANUAL
+        end
+
+        say "hive: detected #{CHANNEL_LABELS[@channel]} install"
+        say "hive: running: #{command.join(' ')}"
+        return EXIT_OK if @dry_run
+
+        out, err, status = @runner.call(command)
+        $stdout.write(out) unless out.to_s.empty?
+        warn err unless err.to_s.empty?
+        status.success? ? EXIT_OK : (raise Hive::Error, "#{command.join(' ')} failed")
+      rescue Hive::Channel::AmbiguousChannel => e
+        warn "hive: #{e.message}"
+        raise
+      end
+
+      private
+
+      def print_unknown_channel_help
+        say "hive: could not determine how this copy of hive was installed"
+        say "  (#@bin_path matches no known channel)"
+        say ""
+        say "  Upgrade manually via your install channel:"
+        say "    brew upgrade hive            # Homebrew tap"
+        say "    yay -Syu hive-bin            # AUR"
+        say "    curl -fsSL <release-url>/install.sh | bash   # one-liner"
+        say "  or re-run the installer you originally used."
+      end
+
+      def print_pacman_hint
+        say "hive: detected pacman (AUR hive-bin) install"
+        say ""
+        say "  Upgrade manually with:"
+        say "    sudo pacman -Syu          # full system sync (recommended)"
+        say "    yay -Syu hive-bin         # if you use an AUR helper"
+        say ""
+        say "  hive never runs sudo on your behalf."
+      end
+
+      def say(message)
+        @output.puts message
+      rescue Errno::EPIPE
+        nil
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index a67097d8d..db9829eaf 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -160,6 +160,10 @@ module Hive
       # across every registered project, so runtime code loads these
       # from ~/Dev/hive/config.yml via load_global_bot. The token lives
       # only in HIVE_TELEGRAM_BOT_TOKEN and is never persisted.
+      # The literal pid/log paths below are LEGACY placeholders kept for
+      # shape stability; Hive::Config.global_bot_defaults overrides them
+      # with the resolved XDG state-home locations at load time (see U2
+      # of the packaging plan). Never read them directly.
       "bot" => {
         "enabled" => false,
         "chat_id_allowlist" => [],
@@ -170,11 +174,11 @@ module Hive
         "codex_budget_usd" => 1,
         "codex_timeout_sec" => 120,
         "shutdown_grace_sec" => 60,
-        "pid_file" => "~/Dev/hive/.bot.pid",
-        "log_file" => "~/Dev/hive/logs/bot.log",
+        "pid_file" => "~/.local/state/hive/.bot.pid",
+        "log_file" => "~/.local/state/hive/logs/bot.log",
         "log_max_bytes" => 10_485_760,
         "log_max_files" => 5,
-        "last_seen_state_file" => "~/Dev/hive/.bot.last_seen_update_id"
+        "last_seen_state_file" => "~/.local/state/hive/.bot.last_seen_update_id"
       },
       # Auto-rebase pre-step for `hive run` (plan
       # docs/plans/2026-05-14-001-feat-hive-auto-rebase-stale-worktree-plan.md).
@@ -208,12 +212,114 @@ module Hive
 
     module_function
 
+    # ── Global path resolution (XDG layout) ─────────────────────────────
+    #
+    # Hive's durable per-project state is <project>/.hive-state/ — a git
+    # worktree of the orphan branch hive/state. It never moves. Only
+    # hive's GLOBAL files follow the XDG best-practice layout:
+    #
+    #   config : $HIVE_CONFIG_HOME → ~/.config/hive/config.yml
+    #            (or $XDG_CONFIG_HOME/hive/config.yml)
+    #   state  : ~/.local/state/hive/  (daemon PID, logs)
+    #   cache  : ~/.cache/hive/
+    #
+    # Two compatibility modes keep existing installs working:
+    #
+    #   * Dev-checkout mode: $HIVE_HOME set (pointing at a source tree or
+    #     an old-style home) keeps the pre-XDG layout exactly as before —
+    #     config at $HIVE_HOME/config.yml, daemon PID at $HIVE_HOME/.daemon.pid.
+    #   * Legacy fallback: on a machine where no env vars are set and
+    #     ~/.config/hive/config.yml does not exist but ~/Dev/hive/config.yml
+    #     does, the legacy path is used for reads AND writes so legacy
+    #     users are never stranded; a one-time stderr notice suggests the
+    #     migration.
+
+    def legacy_mode?
+      e = ENV["HIVE_HOME"]
+      !(e.nil? || e.empty?)
+    end
+
+    def xdg_dir(env_var, default_suffix)
+      dir = ENV[env_var]
+      return dir unless dir.nil? || dir.empty?
+
+      File.join(File.expand_path("~"), default_suffix)
+    end
+
+    # Directory holding the global config.yml. Resolution order:
+    #   $HIVE_CONFIG_HOME → $HIVE_HOME (dev-checkout mode) →
+    #   $XDG_CONFIG_HOME/hive → ~/.config/hive
+    def config_home
+      dir = ENV["HIVE_CONFIG_HOME"]
+      return dir unless dir.nil? || dir.empty?
+
+      dir = ENV["HIVE_HOME"]
+      return dir unless dir.nil? || dir.empty?
+
+      File.join(xdg_dir("XDG_CONFIG_HOME", ".config"), "hive")
+    end
+
+    # Directory holding mutable runtime state that should survive reboots
+    # but is not config: the daemon PID file and its logs.
+    # In dev-checkout ($HIVE_HOME) mode this stays inside HIVE_HOME so a
+    # source checkout remains fully self-contained.
+    def state_home
+      dir = ENV["HIVE_STATE_HOME"]
+      return File.join(dir, "hive") unless dir.nil? || dir.empty?
+
+      return hive_home if legacy_mode?
+
+      File.join(xdg_dir("XDG_STATE_HOME", ".local/state"), "hive")
+    end
+
+    # Directory holding non-essential cached data (safe to delete).
+    def cache_home
+      dir = ENV["HIVE_CACHE_HOME"]
+      return File.join(dir, "hive") unless dir.nil? || dir.empty?
+
+      return File.join(hive_home, "cache") if legacy_mode?
+
+      File.join(xdg_dir("XDG_CACHE_HOME", ".cache"), "hive")
+    end
+
     def hive_home
       ENV["HIVE_HOME"] || File.expand_path("~/Dev/hive")
     end
 
+    # Pre-XDG global config location. Still honoured as a read+write
+    # fallback when the XDG path has never been created.
+    def legacy_global_config_path
+      File.join(ENV["HIVE_HOME"] || File.expand_path("~/Dev/hive"), "config.yml")
+    end
+
+    @migration_notice_printed = false
+    class << self
+      attr_accessor :migration_notice_printed
+    end
+
+    def print_migration_notice!(path)
+      return if migration_notice_printed
+
+      self.migration_notice_printed = true
+      warn "hive: note — using legacy global config at #{path}; " \
+           "consider moving it to #{File.join(config_home, 'config.yml')}"
+    rescue Errno::EPIPE
+      nil
+    end
+
     def global_config_path
-      File.join(hive_home, "config.yml")
+      primary = File.join(config_home, "config.yml")
+      return primary if File.exist?(primary)
+
+      legacy = legacy_global_config_path
+      return primary if legacy == primary
+      return primary unless File.exist?(legacy)
+
+      # XDG path absent, legacy present → stay on the legacy file so an
+      # existing install keeps seeing its registry (and writes land where
+      # reads happen). The one-time notice points the way forward.
+      print_migration_notice!(legacy)
+      legacy
     end
 
     def hive_state_dir(project_root, hive_state_name = ".hive-state")
@@ -386,14 +492,14 @@ module Hive
 
     def global_bot_defaults
       defaults = deep_dup(DEFAULTS["bot"])
-      defaults["pid_file"] = File.join(hive_home, ".bot.pid")
-      defaults["log_file"] = File.join(hive_home, "logs", "bot.log")
-      defaults["last_seen_state_file"] = File.join(hive_home, ".bot.last_seen_update_id")
+      defaults["pid_file"] = File.join(state_home, ".bot.pid")
+      defaults["log_file"] = File.join(state_home, "logs", "bot.log")
+      defaults["last_seen_state_file"] = File.join(state_home, ".bot.last_seen_update_id")
       defaults
     end
 
     def register_project(name:, path:)
-      FileUtils.mkdir_p(hive_home)
+      FileUtils.mkdir_p(File.dirname(global_config_path))
       data = if File.exist?(global_config_path)
                load_global_config(global_config_path)
       else
diff --git a/lib/hive/service.rb b/lib/hive/service.rb
new file mode 100644
index 000000000..338b50dbf
--- /dev/null
+++ b/lib/hive/service.rb
@@ -0,0 +1,243 @@
+require "erb"
+require "fileutils"
+
+module Hive
+  # OS service registration for the hive daemon (packaging plan U6).
+  #
+  # Two backends:
+  #   * :launchd — macOS user agent at ~/Library/LaunchAgents/dev.hive.daemon.plist
+  #   * :systemd — Linux user unit at ~/.config/systemd/user/hive.service
+  #
+  # `hive init` offers one identical prompt on both platforms ("Register +
+  # start the hive daemon now? [Y/n]"); the answer drives enable+start vs
+  # register-only. Non-TTY runs NEVER autostart — they register the unit
+  # file only. Set HIVE_SKIP_SERVICE_REGISTRATION=1 to skip registration
+  # entirely (used by the test suite).
+  #
+  # When a service is registered, `hive daemon {start,stop,status}`
+  # delegate to launchctl / systemctl --user; otherwise they fall back to
+  # the historical PID-file mode (dev checkouts).
+  module Service
+    LABEL = "dev.hive.daemon".freeze
+    UNIT_NAME = "hive.service".freeze
+
+    class ServiceError < Hive::Error; end
+
+    module_function
+
+    # Detect the service backend for this machine. :none means "no
+    # backend" (unsupported OS, or Linux without a user systemd instance)
+    # and every entry point becomes a no-op.
+    def platform
+      return :launchd if RUBY_PLATFORM.include?("darwin")
+      return :systemd if File.exist?("/run/systemd/system") || File.exist?("/run/user/#{Process.uid}/systemd")
+
+      :none
+    end
+
+    # Path of the unit/plist file for the given platform. `home:` is
+    # injectable for tests; production resolves ~.
+    def unit_path(platform: nil, home: nil)
+      platform ||= self.platform
+      base = home || File.expand_path("~")
+      case platform
+      when :launchd then File.join(base, "Library", "LaunchAgents", "#{LABEL}.plist")
+      when :systemd then File.join(base, ".config", "systemd", "user", UNIT_NAME)
+      else nil
+      end
+    end
+
+    def installed?(platform: nil, home: nil)
+      path = unit_path(platform: platform, home: home)
+      !path.nil? && File.exist?(path)
+    end
+
+    def skipped?
+      ENV["HIVE_SKIP_SERVICE_REGISTRATION"] == "1"
+    end
+
+    # Render the unit/plist content for the current installation. Both
+    # backends run `hive daemon start` in the FOREGROUND: launchd and
+    # systemd both expect a long-lived child they can supervise.
+    def render_unit(platform:, hive_bin:, log_file:)
+      template_path = File.expand_path("../../templates/#{template_name(platform)}", __dir__)
+      template = File.read(template_path)
+      erb = ERB.new(template, trim_mode: "-")
+      erb.result(binding)
+    end
+
+    def template_name(platform)
+      case platform
+      when :launchd then "dev.hive.daemon.plist.erb"
+      when :systemd then "hive.service.erb"
+      else raise ServiceError, "no service template for platform #{platform.inspect}"
+      end
+    end
+
+    # Write the unit file and optionally enable + start it. Idempotent:
+    # re-running overwrites the unit in place. Returns the unit path.
+    #
+    # `runner:` is the command executor (injectable for tests); it takes
+    # an argv Array and returns [stdout, stderr, status].
+    def install!(enable_and_start:, platform: nil, home: nil, hive_bin: nil,
+                 log_file: nil, runner: nil, output: $stderr)
+      platform ||= self.platform
+      return nil if platform == :none
+
+      hive_bin ||= default_hive_bin
+      log_file ||= File.join(Hive::Config.state_home, "logs", "daemon.log")
+      runner ||= ->(argv) { Open3.capture3(*argv) }
+
+      path = unit_path(platform: platform, home: home)
+      FileUtils.mkdir_p(File.dirname(path))
+      File.write(path, render_unit(platform: platform, hive_bin: hive_bin, log_file: log_file))
+
+      argvs = if enable_and_start
+                enable_argv(platform: platform, home: home)
+      else
+                reload_argv(platform: platform, home: home)
+      end
+      report_failure!(output, path, argvs) do
+        argvs.each do |argv|
+          _out, err, status = run(runner, argv)
+          raise ServiceError, "#{argv.join(' ')} failed: #{err.strip}" unless status.success?
+        end
+      end
+
+      verb = enable_and_start ? "registered + started" : "registered (not enabled)"
+      say(output, "hive: daemon service #{verb}: #{path}")
+      path
+    end
+
+    # Remove the registration: disable/stop first, then delete the unit.
+    # Safe to call repeatedly (idempotent), safe to call when nothing is
+    # registered. Never raises on backend-command failure — uninstall
+    # must always make progress.
+    def remove!(platform: nil, home: nil, runner: nil, output: $stderr)
+      platform ||= self.platform
+      path = unit_path(platform: platform, home: home)
+      return false if path.nil? || !File.exist?(path)
+
+      runner ||= ->(argv) { Open3.capture3(*argv) }
+      remove_argv(platform: platform, home: home).each do |argv|
+        begin
+          run(runner, argv)
+        rescue StandardError
+          # best-effort: the file removal below is the authoritative step
+        end
+      end
+      FileUtils.rm_f(path)
+      say(output, "hive: daemon service removed: #{path}")
+      true
+    end
+
+    # ── daemon delegation (used by `hive daemon {start,stop,status}`) ──
+
+    def running?(platform: nil, home: nil, runner: nil)
+      platform ||= self.platform
+      return false unless installed?(platform: platform, home: home)
+
+      runner ||= ->(argv) { Open3.capture3(*argv) }
+      case platform
+      when :launchd
+        _out, _err, status = run(runner, ["launchctl", "print", "gui/#{Process.uid}/#{LABEL}"])
+        status.success?
+      when :systemd
+        out, _err, _status = run(runner, ["systemctl", "--user", "is-active", UNIT_NAME])
+        out.strip == "active"
+      else
+        false
+      end
+    end
+
+    def start!(platform: nil, home: nil, runner: nil)
+      platform ||= self.platform
+      return false unless installed?(platform: platform, home: home)
+
+      runner ||= ->(argv) { Open3.capture3(*argv) }
+      argv = case platform
+             when :launchd then ["launchctl", "start", LABEL]
+             when :systemd then ["systemctl", "--user", "start", UNIT_NAME]
+             end
+      _out, err, status = run(runner, argv)
+      raise ServiceError, "service start failed: #{err.strip}" unless status.success?
+
+      true
+    end
+
+    def stop!(platform: nil, home: nil, runner: nil)
+      platform ||= self.platform
+      return false unless installed?(platform: platform, home: home)
+
+      runner ||= ->(argv) { Open3.capture3(*argv) }
+      argv = case platform
+             when :launchd then ["launchctl", "stop", LABEL]
+             when :systemd then ["systemctl", "--user", "stop", UNIT_NAME]
+             end
+      run(runner, argv)
+      true
+    end
+
+    # ── internals ────────────────────────────────────────────────────────
+
+    def default_hive_bin
+      File.expand_path($PROGRAM_NAME)
+    end
+
+    def enable_argv(platform:, home: nil)
+      case platform
+      when :launchd
+        [ ["launchctl", "unload", "-w", unit_path(platform: platform, home: home)],
+          ["launchctl", "load", "-w", unit_path(platform: platform, home: home)] ]
+      when :systemd
+        reload_argv(platform: platform, home: home) +
+          [ ["systemctl", "--user", "enable", "--now", UNIT_NAME] ]
+      else
+        []
+      end
+    end
+
+    # Commands for register-only (write unit, never autostart): systemd
+    # needs a daemon-reload so the new unit is known; launchd needs nothing
+    # — an unloaded plist is inert by definition.
+    def reload_argv(platform:, home: nil)
+      case platform
+      when :systemd
+        [ ["systemctl", "--user", "daemon-reload"] ]
+      else
+        []
+      end
+    end
+
+    def remove_argv(platform:, home: nil)
+      case platform
+      when :launchd
+        [ ["launchctl", "unload", "-w", unit_path(platform: platform, home: home)] ]
+      when :systemd
+        [ ["systemctl", "--user", "disable", "--now", UNIT_NAME],
+          ["systemctl", "--user", "daemon-reload"] ]
+      else
+        []
+      end
+    end
+
+    def run(runner, argv)
+      runner.call(argv)
+    end
+
+    def report_failure!(output, path, argvs)
+      yield
+    rescue StandardError => e
+      say(output, "hive: warning — service commands failed after writing #{path}: #{e.message}")
+      say(output, "  enable manually with: #{argvs.map { |a| a.join(' ') }.join(' && ')}")
+    end
+
+    def say(output, message)
+      output.call(message)
+    rescue NoMethodError
+      output.puts message
+    rescue Errno::EPIPE
+      nil
+    end
+  end
+end
diff --git a/packaging/aur/PKGBUILD b/packaging/aur/PKGBUILD
new file mode 100644
index 000000000..317bb2461
--- /dev/null
+++ b/packaging/aur/PKGBUILD
@@ -0,0 +1,34 @@
+# Maintainer : see https://github.com/ivankuznetsov/hive
+# Upstream   : https://github.com/ivankuznetsov/hive
+# AUR package: hive-bin (prebuilt Release bundle; hive-git may come later)
+
+pkgname=hive-bin
+pkgver=0.1.0
+pkgrel=1
+pkgdesc="Folder-as-agent pipeline: LLM-driven task orchestration CLI (prebuilt binary bundle)"
+arch=('x86_64')
+url="https://github.com/ivankuznetsov/hive"
+license=('MIT')
+depends=('bash' 'git')
+optdepends=('claude-code: default agent CLI'
+            'github-cli: PR automation'
+            'jq: JSON tooling'
+            'tmux: interactive brainstorm runtime')
+provides=('hive')
+conflicts=('hive')
+source=("hive-${pkgver}-linux-x86_64-gnu.tar.gz::https://github.com/ivankuznetsov/hive/releases/download/v${pkgver}/hive-${pkgver}-linux-x86_64-gnu.tar.gz")
+# Filled by packaging/aur/generate-srcinfo.sh from the Release SHA256SUMS
+sha256sums=('SKIP')
+
+# The bundle is self-contained (vendored Ruby + gems): no system ruby
+# dependency, by contract (see packaging/README.md).
+options=('!strip')
+
+package() {
+  install -d -m 755 "${pkgdir}/opt/hive"
+  cp -r "${srcdir}/hive-${pkgver}-linux-x86_64-gnu" "${pkgdir}/opt/hive/${pkgver}"
+
+  # /usr/bin/hive → the symlink-safe shim inside the bundle.
+  install -d -m 755 "${pkgdir}/usr/bin"
+  ln -s "/opt/hive/${pkgver}/hive" "${pkgdir}/usr/bin/hive"
+}
diff --git a/packaging/aur/generate-srcinfo.sh b/packaging/aur/generate-srcinfo.sh
new file mode 100755
index 000000000..350d5a08e
--- /dev/null
+++ b/packaging/aur/generate-srcinfo.sh
@@ -0,0 +1,46 @@
+#!/usr/bin/env bash
+#
+# packaging/aur/generate-srcinfo.sh — regenerate .SRCINFO for the AUR
+# hive-bin package with real sha256 digests pulled from a Release.
+#
+# Usage:
+#   packaging/aur/generate-srcinfo.sh <version> [SHA256SUMS-file]
+#     <version>         release version WITHOUT the leading v (e.g. 0.1.0)
+#     [SHA256SUMS-file] optional local SHA256SUMS; otherwise fetched from
+#                       https://github.com/ivankuznetsov/hive/releases/download/v<version>/SHA256SUMS
+#
+# Run this inside packaging/aur/ (makepkg must be available; on non-Arch
+# hosts use a clean chroot or devtools container).
+
+set -euo pipefail
+
+VERSION="${1:?usage: generate-srcinfo.sh <version> [SHA256SUMS-file]}"
+SUMS="${2:-}"
+HERE="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
+
+log() { printf '[srcinfo] %s\n' "$*"; }
+die() { printf '[srcinfo] ERROR: %s\n' "$*" >&2; exit 1; }
+
+TARBALL="hive-${VERSION}-linux-x86_64-gnu.tar.gz"
+
+if [[ -z "$SUMS" ]]; then
+  SUMS="$(mktemp)"
+  trap 'rm -f "$SUMS"' EXIT
+  log "fetching SHA256SUMS for v${VERSION}"
+  curl -fsSL -o "$SUMS" \
+    "https://github.com/ivankuznetsov/hive/releases/download/v${VERSION}/SHA256SUMS"
+fi
+
+SHA="$(grep " ${TARBALL}\$" "$SUMS" | awk '{print $1}')"
+[[ -n "$SHA" ]] || die "no checksum entry for $TARBALL in $SUMS"
+
+log "digest: $SHA"
+sed -i "s|^sha256sums=('.*')|sha256sums=('${SHA}')|" "$HERE/PKGBUILD"
+sed -i "s|^pkgver=.*|pkgver=${VERSION}|" "$HERE/PKGBUILD"
+
+command -v makepkg >/dev/null 2>&1 ||
+  die "makepkg not found; run inside an Arch chroot/container (see README)"
+
+( cd "$HERE" && makepkg --printsrcinfo > .SRCINFO )
+log "wrote $HERE/.SRCINFO"
+log "next: follow packaging/aur/README.md to publish to the AUR"
